--- gcc-4.0.0.orig/gcc/java/except.c	3 Dec 2004 18:11:21 -0000	1.47
+++ gcc-4.0.0/gcc/java/except.c	28 Apr 2005 16:35:22 -0000	1.47.10.1
@@ -1,5 +1,5 @@
 /* Handle exceptions for GNU compiler for the Java(TM) language.
-   Copyright (C) 1997, 1998, 1999, 2000, 2002, 2003, 2004
+   Copyright (C) 1997, 1998, 1999, 2000, 2002, 2003, 2004, 2005
    Free Software Foundation, Inc.
 
 This file is part of GCC.
@@ -42,7 +42,6 @@
 static void expand_start_java_handler (struct eh_range *);
 static struct eh_range *find_handler_in_range (int, struct eh_range *,
 					       struct eh_range *);
-static void link_handler (struct eh_range *, struct eh_range *);
 static void check_start_handlers (struct eh_range *, int);
 static void free_eh_ranges (struct eh_range *range);
 
@@ -50,8 +49,6 @@
 
 struct eh_range *current_try_block = NULL;
 
-struct eh_range *eh_range_freelist = NULL;
-
 /* These variables are used to speed up find_handler. */
 
 static int cache_range_start, cache_range_end;
@@ -62,12 +59,61 @@
 
 struct eh_range whole_range;
 
+/* Check the invariants of the structure we're using to contain
+   exception regions.  Either returns true or fails an assertion
+   check.  */
+
+bool
+sanity_check_exception_range (struct eh_range *range)
+{
+  struct eh_range *ptr = range->first_child;
+  for (; ptr; ptr = ptr->next_sibling)
+    {
+      gcc_assert (ptr->outer == range
+		  && ptr->end_pc > ptr->start_pc);
+      if (ptr->next_sibling)
+	gcc_assert (ptr->next_sibling->start_pc >= ptr->end_pc);
+      gcc_assert (ptr->start_pc >= ptr->outer->start_pc
+		  && ptr->end_pc <=  ptr->outer->end_pc);
+      (void) sanity_check_exception_range (ptr);
+    }
+
+  return true;
+}
+
 #if defined(DEBUG_JAVA_BINDING_LEVELS)
-extern int binding_depth;
 extern int is_class_level;
 extern int current_pc;
-extern void indent ();
+extern int binding_depth;
+extern void indent (void);
+static void
+print_ranges (struct eh_range *range)
+{
+  if (! range)
+    return;
+
+  struct eh_range *child = range->first_child;
+  
+  indent ();
+  fprintf (stderr, "handler pc %d --> %d ", range->start_pc, range->end_pc);
+  
+  tree handler = range->handlers;
+  for ( ; handler != NULL_TREE; handler = TREE_CHAIN (handler))
+    {
+      tree type = TREE_PURPOSE (handler);
+      if (type == NULL)
+	type = throwable_type_node;
+      fprintf (stderr, " type=%s ", IDENTIFIER_POINTER (DECL_NAME (TYPE_NAME (type))));
+    }
+  fprintf (stderr, "\n");
+
+  int saved = binding_depth;
+  binding_depth++;
+  print_ranges (child);
+  binding_depth = saved;
 
+  print_ranges (range->next_sibling);
+}
 #endif
 
 /* Search for the most specific eh_range containing PC.
@@ -117,114 +163,6 @@
   return find_handler_in_range (pc, h, cache_next_child);
 }
 
-/* Recursive helper routine for check_nested_ranges. */
-
-static void
-link_handler (struct eh_range *range, struct eh_range *outer)
-{
-  struct eh_range **ptr;
-
-  if (range->start_pc == outer->start_pc && range->end_pc == outer->end_pc)
-    {
-      outer->handlers = chainon (outer->handlers, range->handlers);
-      return;
-    }
-
-  /* If the new range completely encloses the `outer' range, then insert it
-     between the outer range and its parent.  */
-  if (range->start_pc <= outer->start_pc && range->end_pc >= outer->end_pc)
-    {
-      range->outer = outer->outer;
-      range->next_sibling = NULL;
-      range->first_child = outer;
-      {
-	struct eh_range *p = outer;
-	struct eh_range **pr = &(outer->outer->first_child);
-	while (*pr != outer)
-	  pr = &(*pr)->next_sibling;
-	*pr = range;
-
-	while (p)
-	  {
-	    p->outer = range;
-	    p = p->next_sibling;
-	  }
-      }
-      return;
-    }
-
-  /* Handle overlapping ranges by splitting the new range.  */
-  if (range->start_pc < outer->start_pc || range->end_pc > outer->end_pc)
-    {
-      struct eh_range *h = xmalloc (sizeof (struct eh_range));
-      if (range->start_pc < outer->start_pc)
-	{
-	  h->start_pc = range->start_pc;
-	  h->end_pc = outer->start_pc;
-	  range->start_pc = outer->start_pc;
-	}
-      else
-	{
-	  h->start_pc = outer->end_pc;
-	  h->end_pc = range->end_pc;
-	  range->end_pc = outer->end_pc;
-	}
-      h->first_child = NULL;
-      h->outer = NULL;
-      h->handlers = build_tree_list (TREE_PURPOSE (range->handlers),
-				     TREE_VALUE (range->handlers));
-      h->next_sibling = NULL;
-      h->expanded = 0;
-      h->stmt = NULL;
-      /* Restart both from the top to avoid having to make this
-	 function smart about reentrancy.  */
-      link_handler (h, &whole_range);
-      link_handler (range, &whole_range);
-      return;
-    }
-
-  ptr = &outer->first_child;
-  for (;; ptr = &(*ptr)->next_sibling)
-    {
-      if (*ptr == NULL || range->end_pc <= (*ptr)->start_pc)
-	{
-	  range->next_sibling = *ptr;
-	  range->first_child = NULL;
-	  range->outer = outer;
-	  *ptr = range;
-	  return;
-	}
-      else if (range->start_pc < (*ptr)->end_pc)
-	{
-	  link_handler (range, *ptr);
-	  return;
-	}
-      /* end_pc > (*ptr)->start_pc && start_pc >= (*ptr)->end_pc. */
-    }
-}
-
-/* The first pass of exception range processing (calling add_handler)
-   constructs a linked list of exception ranges.  We turn this into
-   the data structure expected by the rest of the code, and also
-   ensure that exception ranges are properly nested.  */
-
-void
-handle_nested_ranges (void)
-{
-  struct eh_range *ptr, *next;
-
-  ptr = whole_range.first_child;
-  whole_range.first_child = NULL;
-  for (; ptr; ptr = next)
-    {
-      next = ptr->next_sibling;
-      ptr->next_sibling = NULL;
-      link_handler (ptr, &whole_range);
-    }
-}
-
-/* Free RANGE as well as its children and siblings.  */
-
 static void
 free_eh_ranges (struct eh_range *range)
 {
@@ -252,55 +190,166 @@
   cache_range_start = 0xFFFFFF;
 }
 
-/* Add an exception range.  If we already have an exception range
-   which has the same handler and label, and the new range overlaps
-   that one, then we simply extend the existing range.  Some bytecode
-   obfuscators generate seemingly nonoverlapping exception ranges
-   which, when coalesced, do in fact nest correctly.
-   
-   This constructs an ordinary linked list which check_nested_ranges()
-   later turns into the data structure we actually want.
+/* Split an exception range into two at PC.  The sub-ranges that
+   belong to the range are split and distributed between the two new
+   ranges.  */
+
+static void
+split_range (struct eh_range *range, int pc)
+{
+  struct eh_range *ptr;
+  struct eh_range **first_child, **second_child;
+  struct eh_range *h;
+
+  /* First, split all the sub-ranges.  */
+  for (ptr = range->first_child; ptr; ptr = ptr->next_sibling)
+    {
+      if (pc > ptr->start_pc
+	  && pc < ptr->end_pc)
+	{
+	  split_range (ptr, pc);
+	}
+    }
+
+  /* Create a new range.  */
+  h = xmalloc (sizeof (struct eh_range));
+
+  h->start_pc = pc;
+  h->end_pc = range->end_pc;
+  h->next_sibling = range->next_sibling;
+  range->next_sibling = h;
+  range->end_pc = pc;
+  h->handlers = build_tree_list (TREE_PURPOSE (range->handlers),
+				 TREE_VALUE (range->handlers));
+  h->next_sibling = NULL;
+  h->expanded = 0;
+  h->stmt = NULL;
+  h->outer = range->outer;
+  h->first_child = NULL;
+
+  ptr = range->first_child;
+  first_child = &range->first_child;
+  second_child = &h->first_child;
+
+  /* Distribute the sub-ranges bewteen the two new ranges.  */
+  for (ptr = range->first_child; ptr; ptr = ptr->next_sibling)
+    {
+      if (ptr->start_pc < pc)
+	{
+	  *first_child = ptr;
+	  ptr->outer = range;
+	  first_child = &ptr->next_sibling;
+	}
+      else
+	{
+	  *second_child = ptr;
+	  ptr->outer = h;
+	  second_child = &ptr->next_sibling;
+	}
+    }
+  *first_child = NULL;
+  *second_child = NULL;
+}  
+
+
+/* Add an exception range. 
+
+   There are some missed optimization opportunities here.  For
+   example, some bytecode obfuscators generate seemingly
+   nonoverlapping exception ranges which, when coalesced, do in fact
+   nest correctly.  We could merge these, but we'd have to fix up all
+   the enclosed regions first and perhaps create a new range anyway if
+   it overlapped existing ranges.
    
-   We expect the input to come in order of increasing START_PC.  This
-   function doesn't attempt to detect the case where two previously
-   added disjoint ranges could be coalesced by a new range; that is
-   what the sorting counteracts.  */
+   Also, we don't attempt to detect the case where two previously
+   added disjoint ranges could be coalesced by a new range.  */
 
-void
+void 
 add_handler (int start_pc, int end_pc, tree handler, tree type)
 {
-  struct eh_range *ptr, *prev = NULL, *h;
+  struct eh_range *ptr, *h;
+  struct eh_range **first_child, **prev;
 
+  /* First, split all the existing ranges that we need to enclose.  */
   for (ptr = whole_range.first_child; ptr; ptr = ptr->next_sibling)
     {
-      if (start_pc >= ptr->start_pc
-	  && start_pc <= ptr->end_pc
-	  && TREE_PURPOSE (ptr->handlers) == type
-	  && TREE_VALUE (ptr->handlers) == handler)
+      if (start_pc > ptr->start_pc
+	  && start_pc < ptr->end_pc)
 	{
-	  /* Already found an overlapping range, so coalesce.  */
-	  ptr->end_pc = MAX (ptr->end_pc, end_pc);
-	  return;
+	  split_range (ptr, start_pc);
 	}
-      prev = ptr;
+
+      if (end_pc > ptr->start_pc
+	  && end_pc < ptr->end_pc)
+	{
+	  split_range (ptr, end_pc);
+	}
+
+      if (ptr->start_pc >= end_pc)
+	break;
     }
 
+  /* Create the new range.  */
   h = xmalloc (sizeof (struct eh_range));
+  first_child = &h->first_child;
+
   h->start_pc = start_pc;
   h->end_pc = end_pc;
   h->first_child = NULL;
-  h->outer = NULL;
+  h->outer = NULL_EH_RANGE;
   h->handlers = build_tree_list (type, handler);
   h->next_sibling = NULL;
   h->expanded = 0;
   h->stmt = NULL;
 
-  if (prev == NULL)
-    whole_range.first_child = h;
-  else
-    prev->next_sibling = h;
-}
+  /* Find every range at the top level that will be a sub-range of the
+     range we're inserting and make it so.  */
+  {
+    struct eh_range **prev = &whole_range.first_child;
+    for (ptr = *prev; ptr;)
+      {
+	struct eh_range *next = ptr->next_sibling;
+
+	if (ptr->start_pc >= end_pc)
+	  break;
 
+	if (ptr->start_pc < start_pc)
+	  {
+	    prev = &ptr->next_sibling;
+	  }
+	else if (ptr->start_pc >= start_pc
+		 && ptr->start_pc < end_pc)
+	  {
+	    *prev = next;
+	    *first_child = ptr;
+	    first_child = &ptr->next_sibling;
+	    ptr->outer = h;
+	    ptr->next_sibling = NULL;	  
+	  }
+
+	ptr = next;
+      }
+  }
+
+  /* Find the right place to insert the new range.  */
+  prev = &whole_range.first_child;
+  for (ptr = *prev; ptr; prev = &ptr->next_sibling, ptr = ptr->next_sibling)
+    {
+      gcc_assert (ptr->outer == NULL_EH_RANGE);
+      if (ptr->start_pc >= start_pc)
+	break;
+    }
+
+  /* And insert it there.  */
+  *prev = h;
+  if (ptr)
+    {
+      h->next_sibling = ptr;
+      h->outer = ptr->outer;
+    }
+}
+      
+  
 /* if there are any handlers for this range, issue start of region */
 static void
 expand_start_java_handler (struct eh_range *range)
--- gcc-4.0.0.orig/gcc/java/expr.c	17 Mar 2005 15:33:30 -0000	1.218.4.2
+++ gcc-4.0.0/gcc/java/expr.c	28 Apr 2005 16:35:21 -0000	1.218.4.3
@@ -3484,7 +3484,8 @@
    For method invocation, we modify the arguments so that a
    left-to-right order evaluation is performed. Saved expressions
    will, in CALL_EXPR order, be reused when the call will be expanded.
-*/
+
+   We also promote outgoing args if needed.  */
 
 tree
 force_evaluation_order (tree node)
@@ -3518,7 +3519,18 @@
       /* This reverses the evaluation order. This is a desired effect. */
       for (cmp = NULL_TREE; arg; arg = TREE_CHAIN (arg))
 	{
-	  tree saved = save_expr (force_evaluation_order (TREE_VALUE (arg)));
+	  /* Promote types smaller than integer.  This is required by
+	     some ABIs.  */
+	  tree saved;
+	  tree type = TREE_TYPE (TREE_VALUE (arg));
+	  if (targetm.calls.promote_prototypes (type)
+	      && INTEGRAL_TYPE_P (type)
+	      && INT_CST_LT_UNSIGNED (TYPE_SIZE (type),
+				      TYPE_SIZE (integer_type_node)))
+	    TREE_VALUE (arg) 
+	      = fold_convert (integer_type_node, TREE_VALUE (arg));
+
+	  saved = save_expr (force_evaluation_order (TREE_VALUE (arg)));
 	  cmp = (cmp == NULL_TREE ? saved :
 		 build2 (COMPOUND_EXPR, void_type_node, cmp, saved));
 	  TREE_VALUE (arg) = saved;
--- gcc-4.0.0.orig/gcc/java/gjavah.c	2 Feb 2005 00:44:08 -0000	1.128
+++ gcc-4.0.0/gcc/java/gjavah.c	26 Apr 2005 00:30:20 -0000	1.128.6.2
@@ -2388,6 +2388,9 @@
   int emit_dependencies = 0, suppress_output = 0;
   int opt;
 
+  /* Unlock the stdio streams.  */
+  unlock_std_streams ();
+
   gcc_init_libintl ();
 
   if (argc <= 1)
--- gcc-4.0.0.orig/gcc/java/java-except.h	12 Feb 2005 15:21:14 -0000	1.18
+++ gcc-4.0.0/gcc/java/java-except.h	28 Apr 2005 16:35:22 -0000	1.18.4.1
@@ -54,8 +54,6 @@
 
     /* The TRY_CATCH_EXPR for this EH range.  */
     tree stmt;
-
-    tree handler;
   };
 
 /* A dummy range that represents the entire method. */
@@ -67,5 +65,5 @@
 extern void method_init_exceptions (void);
 extern void maybe_start_try (int, int);
 extern void add_handler (int, int, tree, tree);
-extern void handle_nested_ranges (void);
 extern void expand_end_java_handler (struct eh_range *);
+extern bool sanity_check_exception_range (struct eh_range *);
--- gcc-4.0.0.orig/gcc/java/jcf-dump.c	25 Nov 2004 11:13:38 -0000	1.64
+++ gcc-4.0.0/gcc/java/jcf-dump.c	26 Apr 2005 00:30:22 -0000	1.64.12.2
@@ -925,6 +925,9 @@
   JCF jcf[1];
   int argi, opt;
 
+  /* Unlock the stdio streams.  */
+  unlock_std_streams ();
+
   gcc_init_libintl ();
 
   if (argc <= 1)
--- gcc-4.0.0.orig/gcc/java/jv-scan.c	12 Feb 2005 15:21:14 -0000	1.47
+++ gcc-4.0.0/gcc/java/jv-scan.c	26 Apr 2005 00:30:22 -0000	1.47.4.2
@@ -146,6 +146,9 @@
   /* Default for output */
   out = stdout;
 
+  /* Unlock the stdio streams.  */
+  unlock_std_streams ();
+
   gcc_init_libintl ();
 
   /* Process options first.  We use getopt_long and not
--- gcc-4.0.0.orig/gcc/java/jvgenmain.c	10 Feb 2004 19:12:34 -0000	1.35
+++ gcc-4.0.0/gcc/java/jvgenmain.c	26 Apr 2005 00:30:22 -0000	1.35.46.2
@@ -58,6 +58,9 @@
   const char *mangled_classname;
   int i, last_arg;
 
+  /* Unlock the stdio streams.  */
+  unlock_std_streams ();
+
   gcc_init_libintl ();
 
   if (argc < 2)
--- gcc-4.0.0.orig/gcc/java/verify-glue.c	7 Mar 2005 21:37:34 -0000	1.4.2.1
+++ gcc-4.0.0/gcc/java/verify-glue.c	28 Apr 2005 16:35:22 -0000	1.4.2.2
@@ -487,7 +487,7 @@
       instruction_bits[handler_pc] |= BCODE_EXCEPTION_TARGET;
     }
 
-  handle_nested_ranges ();
+  gcc_assert (sanity_check_exception_range (&whole_range));
 
   method.method = current_function_decl;
   method.signature = build_java_signature (TREE_TYPE (current_function_decl));
--- gcc-4.0.0.orig/gcc/java/verify.c	10 Jan 2005 18:14:36 -0000	1.69
+++ gcc-4.0.0/gcc/java/verify.c	28 Apr 2005 16:35:22 -0000	1.69.10.1
@@ -45,7 +45,6 @@
 static tree merge_types (tree, tree);
 static const char *check_pending_block (tree);
 static void type_stack_dup (int, int);
-static int start_pc_cmp (const void *, const void *);
 static char *pop_argument_types (tree);
 
 extern int stack_pointer;
@@ -346,15 +345,6 @@
   int index;
 };
 
-/* A helper that is used when sorting exception ranges.  */
-static int
-start_pc_cmp (const void *xp, const void *yp)
-{
-  const struct pc_index *x = (const struct pc_index *) xp;
-  const struct pc_index *y = (const struct pc_index *) yp;
-  return x->start_pc - y->start_pc;
-}
-
 /* This causes the next iteration to ignore the next instruction
    and look for some other unhandled instruction. */
 #define INVALIDATE_PC (prevpc = -1, oldpc = PC, PC = INVALID_PC)
@@ -448,15 +438,12 @@
   JCF_SEEK (jcf, DECL_CODE_OFFSET (current_function_decl) + length);
   eh_count = JCF_readu2 (jcf);
 
-  /* We read the exception handlers in order of increasing start PC.
-     To do this we first read and sort the start PCs.  */
   starts = xmalloc (eh_count * sizeof (struct pc_index));
   for (i = 0; i < eh_count; ++i)
     {
       starts[i].start_pc = GET_u2 (jcf->read_ptr + 8 * i);
       starts[i].index = i;
     }
-  qsort (starts, eh_count, sizeof (struct pc_index), start_pc_cmp);
 
   for (i = 0; i < eh_count; ++i)
     {
@@ -491,7 +478,6 @@
     }
 
   free (starts);
-  handle_nested_ranges ();
 
   for (PC = 0;;)
     {
--- gcc-4.0.0.orig/gcc/objc/ChangeLog	21 Apr 2005 05:18:54 -0000	1.29.8.2
+++ gcc-4.0.0/gcc/objc/ChangeLog	22 Apr 2005 12:58:18 -0000	1.29.8.3
@@ -1,3 +1,9 @@
+2005-04-22  Joseph S. Myers  <joseph@codesourcery.com>
+
+	PR c/12913
+	* objc-act.c (objc_start_function): Create stack level for context
+	of identifiers with variably modified type.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
--- gcc-4.0.0.orig/gcc/objc/objc-act.c	30 Mar 2005 19:59:13 -0000	1.266.6.1
+++ gcc-4.0.0/gcc/objc/objc-act.c	22 Apr 2005 12:58:19 -0000	1.266.6.2
@@ -7666,12 +7666,19 @@
   cplus_decl_attributes (&fndecl, attrs, 0);
   start_preparsed_function (fndecl, attrs, /*flags=*/SF_DEFAULT);
 #else
-  struct c_label_context *nstack;
-  nstack = XOBNEW (&parser_obstack, struct c_label_context);
-  nstack->labels_def = NULL;
-  nstack->labels_used = NULL;
-  nstack->next = label_context_stack;
-  label_context_stack = nstack;
+  struct c_label_context_se *nstack_se;
+  struct c_label_context_vm *nstack_vm;
+  nstack_se = XOBNEW (&parser_obstack, struct c_label_context_se);
+  nstack_se->labels_def = NULL;
+  nstack_se->labels_used = NULL;
+  nstack_se->next = label_context_stack_se;
+  label_context_stack_se = nstack_se;
+  nstack_vm = XOBNEW (&parser_obstack, struct c_label_context_vm);
+  nstack_vm->labels_def = NULL;
+  nstack_vm->labels_used = NULL;
+  nstack_vm->scope = 0;
+  nstack_vm->next = label_context_stack_vm;
+  label_context_stack_vm = nstack_vm;
   decl_attributes (&fndecl, attrs, 0);
   announce_function (fndecl);
   DECL_INITIAL (fndecl) = error_mark_node;
--- gcc-4.0.0.orig/gcc/po/ChangeLog	21 Apr 2005 05:18:58 -0000	1.135.10.9
+++ gcc-4.0.0/gcc/po/ChangeLog	1 May 2005 10:58:23 -0000	1.135.10.12
@@ -1,3 +1,16 @@
+2005-05-01  Joseph S. Myers  <joseph@codesourcery.com>
+
+	* zh_CN.po: New file.
+
+2005-04-27  Joseph S. Myers  <joseph@codesourcery.com>
+
+	* be.po, ca.po, da.po, de.po, el.po, es.po, fr.po, ja.po, nl.po,
+	rw.po, sv.po, tr.po: Update.
+
+2005-04-24  Joseph S. Myers  <joseph@codesourcery.com>
+
+	* de.po: Update.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
--- gcc-4.0.0.orig/gcc/testsuite/ChangeLog	21 Apr 2005 05:19:08 -0000	1.5084.2.130
+++ gcc-4.0.0/gcc/testsuite/ChangeLog	1 May 2005 01:12:59 -0000	1.5084.2.152
@@ -1,3 +1,131 @@
+2005-05-01  Michael Matz  <matz@suse.de>
+
+	PR c++/19542
+	* g++.dg/warn/sentinel.C: New testcase for __null sentinels added.
+
+2005-04-29  Michael Matz  <matz@suse.de>
+
+	* gcc.dg/inline-mcpy.c: New test.
+
+2005-04-29  Jakub Jelinek  <jakub@redhat.com>
+
+	PR fortran/13082
+	PR fortran/18824
+	* gfortran.dg/entry_4.f90: New test.
+	* gfortran.fortran-torture/execute/entry_1.f90: New test.
+	* gfortran.fortran-torture/execute/entry_2.f90: New test.
+	* gfortran.fortran-torture/execute/entry_3.f90: New test.
+	* gfortran.fortran-torture/execute/entry_4.f90: New test.
+	* gfortran.fortran-torture/execute/entry_5.f90: New test.
+	* gfortran.fortran-torture/execute/entry_6.f90: New test.
+	* gfortran.fortran-torture/execute/entry_7.f90: New test.
+
+2005-04-29  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>
+
+	* gfortran.fortran-torture/execute/entry_8.f90: New test.
+
+2005-04-29  Francois-Xavier Coudert  <coudert@clipper.ens.fr>
+
+	PR fortran/16861
+	* gfortran.dg/pr16861.f90: New test.
+
+2005-04-29  Paul Brook   <paul@codesourcery.com>
+
+	* gfortran.dg/entry_3.f90: New test.
+
+2004-04-29  David Billinghurst (David.Billinghurst@riotinto.com)
+
+	* lib/fortran-torture.exp (fortran-torture.exp): Catch
+	error if file cannot be deleted.
+
+2005-04-28  Francois-Xavier Coudert  <coudert@clipper.ens.fr>
+
+	PR fortran/20865
+	* gfortran.dg/pr20865.f90: New test.
+
+2005-04-28  Joseph S. Myers  <joseph@codesourcery.com>
+
+	* gcc.dg/void-cast-2.c: New test.
+
+2005-04-27  Joseph S. Myers  <joseph@codesourcery.com>
+
+	PR c/21159
+	* gcc.dg/void-cast-1.c: New test.
+
+2005-04-27  Francois-Xavier Coudert  <coudert@clipper.ens.fr>
+
+	PR libfortran/20950
+	* gfortran.dg/pr20950.f: New test.
+
+2005-04-27  Francois-Xavier Coudert  <coudert@clipper.ens.fr>
+
+	PR fortran/21177
+	* gfortran.dg/pr21177.f90: New test.
+
+2005-04-27  Joseph S. Myers  <joseph@codesourcery.com>
+
+	PR c/21213
+	* gcc.dg/transparent-union-3.c: New test.
+
+2005-04-27  Joseph S. Myers  <joseph@codesourcery.com>
+
+	PR c/20740
+	* gcc.dg/format/asm_fprintf-2.c, gcc.dg/format/asm_fprintf-3.c,
+	gcc.dg/format/asm_fprintf-4.c, gcc.dg/format/asm_fprintf-5.c,
+	gcc.dg/format/gcc_diag-2.c, gcc.dg/format/gcc_diag-3.c,
+	gcc.dg/format/gcc_diag-4.c, gcc.dg/format/gcc_diag-5.c,
+	gcc.dg/format/gcc_diag-6.c, gcc.dg/format/gcc_diag-7.c ,
+	gcc.dg/format/gcc_diag-8.c, gcc.dg/format/gcc_diag-9.c: New tests.
+
+2005-04-25  Alexandre Oliva  <aoliva@redhat.com>
+
+	PR c++/21087
+	* g++.dg/lookup/builtin2.C: New test.
+
+2005-04-25  Paul Brook  <paul@codesourcery.com>
+	Steven G. Kargl  <kargls@comcast.net>
+
+	PR fortran/20879
+	* gfortran.dg/ichar_1.f90: New file.
+
+2005-04-24  Per Bothner  <per@bothner.com>
+	    Devang Patel  <dpatel@apple.com>
+
+	PR preprocessor/20907
+	* gcc.dg/cpp/very-long-comment.c: New test.
+
+2005-04-24  Laurent GUERBY  <laurent@guerby.net>
+
+	* ada/acats/run_all.sh: Use sync when executable not present.
+	
+2005-04-24  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>
+
+	PR fortran/20059
+	* gfortran.dg/common_5.f: New test.
+
+2005-04-24  Jakub Jelinek  <jakub@redhat.com>
+
+	* gcc.dg/compat/struct-layout-1_generate.c: In arrays avoid types
+	where sizeof (type) < __alignof__ (type).
+	* gcc.dg/compat/struct-layout-1.h: Likewise.
+
+2005-04-23  Richard Guenther  <rguenth@gcc.gnu.org>
+
+	PR gfortran/14569
+	* gfortran.dg/wtruncate.f: New testcase.
+	* gfortran.dg/wtruncate.f90: New testcase.
+
+2005-04-22  Joseph S. Myers  <joseph@codesourcery.com>
+
+	PR c/12913
+	* gcc.dg/c99-vla-jump-1.c, gcc.dg/c99-vla-jump-2.c,
+	gcc.dg/c99-vla-jump-3.c, gcc.dg/c99-vla-jump-4.c,
+	gcc.dg/c99-vla-jump-5.c: New tests.
+
+2005-04-22  Joseph S. Myers  <joseph@codesourcery.com>
+
+	* gcc.dg/weak/weak-13.c: New test.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
@@ -34,8 +162,8 @@
 
 2005-04-13  Thomas Koenig  <Thomas.Koenig@online.de>
 
-        PR libfortran/20163
-        * gfortran.dg/open-options-blanks.f:  New test.
+	PR libfortran/20163
+	* gfortran.dg/open-options-blanks.f:  New test.
 
 2005-04-12  Ulrich Weigand  <uweigand@de.ibm.com>
 
--- gcc-4.0.0.orig/gcc/testsuite/ada/acats/run_all.sh	26 Apr 2004 21:15:54 -0000	1.18
+++ gcc-4.0.0/gcc/testsuite/ada/acats/run_all.sh	24 Apr 2005 19:19:07 -0000	1.18.42.1
@@ -256,6 +256,9 @@
 
       echo "RUN $binmain" >> $dir/acats.log
       cd $dir/run
+      if [ ! -x $dir/tests/$chapter/$i/$binmain ]; then
+         sync
+      fi
       target_run $dir/tests/$chapter/$i/$binmain > $dir/tests/$chapter/$i/${i}.log 2>&1
       cd $dir/tests/$chapter/$i
       cat ${i}.log >> $dir/acats.log
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/g++.dg/lookup/builtin2.C	25 Apr 2005 20:54:26 -0000	1.2.2.1
@@ -0,0 +1,19 @@
+/* { dg-do compile } */
+
+/* PR c++/21087 */
+
+/* We used to overload the template function with the built-in
+   declaration, instead of replacing it as we should, and then barf at
+   the using decl because of a test that none of the overload set
+   members were anticipated built-ins.  */
+
+extern "C" signed int toupper(signed int __c) throw();
+namespace std
+{
+  template< typename a > a toupper(a,int){}
+  using ::toupper;
+}
+
+int f () {
+  std::toupper((signed int)'a');
+}
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/g++.dg/warn/sentinel.C	1 May 2005 01:12:59 -0000	1.1.2.1
@@ -0,0 +1,11 @@
+/* { dg-do compile } */
+/* { dg-options "-Wall" } */
+extern void ex (int i, ...) __attribute__ ((__sentinel__(0)));
+
+void f()
+{
+  ex (1, 0);		/* { dg-warning "missing sentinel in function call" "" } */
+  ex (1, 0L);		/* { dg-warning "missing sentinel in function call" "" } */
+  ex (1, (void *)0);
+  ex (1, __null);	/* { dg-bogus "sentinel" } */
+}
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gcc.c-torture/execute/pr21173.c	25 Apr 2005 15:20:59 -0000	1.1.2.1
@@ -0,0 +1,21 @@
+void abort (void);
+
+char q;
+void *a[2];
+
+void foo (char *p)
+{
+  int i;
+  for (i = 0; i < 2; i++)
+    a[i] += p - &q;
+}
+
+int main (void)
+{
+  int i;
+  foo (&q);
+  for (i = 0; i < 2; i ++)
+    if (a[i])
+      abort ();
+  return 0;
+}
